/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2015 Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * 
 */
/*
set verbosity = 6.
set debug_level = 6.

set print_level = 5.
*/

set hopchop = true.

/* run */ define test() = {

          exists X : { output(X) and empty ; X = 0 and empty }

}.


/* run */ define test1() = {

          exists X : { {output(X) and empty} ; {X = 0 and empty} }

}.

/* run */ define test2() = {

          exists X : { {always (output(X)) and len(2)} ; {X = 0 and empty} }

}.

/* run */ define test3() = {

          exists X,Y : { {empty and (if (X=1) then Y=1 else Y=2) } ; {X=1 and Y=2 and empty} }

}.

/* run */ define test4() = {

          exists X : { {always (output(X)) and len(2)} ; {X = 0 and skip} }

}.

/* run */ define test5() = {

          exists X,Y : { {always (output(X) and Y=1) and len(2)} ; 
                         {X = 0 and Y:=2 and skip} }

}.

/* run */ define test6() = {

          exists X,Y : { {always (output(X) and output(Y) and Y=1) and len(2)} ; 
                         {X = 0 and len(1) and Y:=2 and {skip;{empty and output(X) and output(Y)}} 
                         } }

}.

/* run */ define test7() = {

          exists X,Y : { {always (output(X)) and Y=1 and stable(Y) and len(2)} ; 
                         {X = 0 and output(Y) and Y:=2 and skip} }

}.
