/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2015 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * tempura code for robot control system
 * OCS : operator control system
 * ICS : infrared control system
 * MCS : motor control system
 */

define move(X,Y) = {
  format("sending left %t  right %t \n", X, Y)
}.

define s = 0.
define f = 20.
define b = -20.
define mvl = [b,b,b,s,f,f,f,s].
define mvr = [b,s,f,f,f,s,b,b].

/* run */ define robot() = {
  exists  Loc, Roc, Lic, Ric, Opactive, Iractive, Ircounts  :
    { list(Ircounts,8) and stable(struct(Ircounts)) and

 define OCS() = {
  exists Lloc, Lroc : { 
   Lloc=s and Lroc=s and
   while true do { 
     len(1) and
     input Loc and input Roc and 
     Lloc:=Loc and Lroc:=Roc and
     Opactive = {if (Lloc ~= Loc) and (Lloc ~= Loc) then 1 else 0}
   }
  }
 } and

define sum(X) = {
  {if Ircounts[0]>100 then X[0] else 0} +
  {if Ircounts[1]>100 then X[1] else 0} +
  {if Ircounts[2]>100 then X[2] else 0} +
  {if Ircounts[3]>100 then X[3] else 0} +
  {if Ircounts[4]>100 then X[4] else 0} +
  {if Ircounts[5]>100 then X[5] else 0} +
  {if Ircounts[6]>100 then X[6] else 0} +
  {if Ircounts[7]>100 then X[7] else 0}
 } and

define ICS() = {
  while true do {
    len(1) and
    input Ircounts and
    Iractive = {if (exists i < 8 : Ircounts[i]>100) then 1 else 0} and
    Lic = sum(mvl) and
    Ric = sum(mvr)
  }
 } and

define MCS() = { 
   while true do { 
    len(1) and
    if Opactive=1 then {
      format("operator move \n") and
      move(Loc,Roc) }
    else {
      if Iractive=1 then {
        format("infrared move \n") and
        move(Lic,Ric) }
      }
  }
 } and 

 MCS() and ICS() and OCS()
 }    
}.
